
#define Char	    char      
#define Short	    short      
#define UChar	    unsigned char      /* unsigned 8 bit integer	(FF hex)*/
#define UShort    unsigned short int /* unsigned 16 bit integer (FFFF hex)*/
#define UInt	    unsigned int       /* unsigned 32 bit integer	(FFFFFFFF hex)*/
#define Int	      signed   int       /* signed 32 bit integer	(80000000 hex) */
#define Detector 0xffc00000
#define nint(a) (((a)<0) ? ((int)(a - 0.5)) : ((int)(a + 0.5)))
#define PEAK 1023
#define RGBYUV //do RGB to YUV conversion

enum FORMAT {YUV, RAS, DPX, SGI};


/***********************************************************************************************************************/
// DPX FORMAT
/***********************************************************************************************************************/

/*generic image data header */
typedef struct file_information
{
    UInt   magic_num;        /* magic number 0x53445058 (SDPX) or 0x58504453 (XPDS) */
    UInt   offset;           /* offset to image data in bytes */
    char vers[8];          /* which header format version is being used (v1.0)*/
    UInt   file_size;        /* file size in bytes */
    char Undefined1[16];
    char Undefined2[624];
    char Undefined3[108];

} FileInformation;

/*Image Information Header*/
typedef struct _image_information
{
    UShort    orientation;          /* image orientation */
    UShort    element_number;       /* number of image elements */
    UInt    pixels_per_line;      /* or x value */
    UInt    lines_per_image_ele;  /* or y value, per element */
    char Undefined1[16];
    
	/*struct _image_element*/
    /*{*/
        UInt    data_sign;        /* data sign (0 = unsigned, 1 = signed ) */

				 /* "Core set images are unsigned" */
        UChar     descriptor;       /* descriptor for image element */
        UChar     transfer;         /* transfer characteristics for element */
        UChar     colorimetric;     /* colormetric specification for element */
        UChar     bit_size;         /* bit size for element */
    	UShort    packing;          /* packing for element */
        UShort    encoding;         /* encoding for element */
        UInt    data_offset;      /* offset to data of element */
#ifdef DCtest
   char Undefined3[7380];
#else
   char Undefined3[64724];
#endif
    /*UChar reserved[52];*/             /* reserved for future use (padding) */
} Image_Information;


typedef struct dpx
{
	FileInformation    fileinfo;
	Image_Information  imageinfo;
}DPXHEADER;

/***********************************************************************************************************************/

typedef struct{
  UChar *Y;
  UChar *U;
  UChar *V;
} YUVimage, *YUVimage_ptr;


/***********************************************************************************************************************/

typedef struct sgi
{
  Short Magic;          /* Identification number (474) */
  Char Storage;         /* Compression flag */
  Char Bpc;             /* Bytes per pixel */
  Short Dimension;       /* Number of image dimensions */
  UShort XSize;           /* Width of image in pixels */
  UShort YSize;           /* Height of image in pixels */
  UShort ZSize;           /* Number of bit planes */
  long PixMin;          /* Smallest pixel value */
  long PixMax;          /* Largest pixel value */
  Char Dummy1[4];       /* Not used */
  Char ImageName[80];   /* Name of image */
  long ColorMap;        /* Format of pixel data */
  Char Dummy2[404];     /* Not used */
} SGIHEADER;

#define   SGI_MAGIC         0x01DA //SGI image file signature
#define 	SGI_HEADER_SIZE   512
#define 	SGI_GRAYSCALE       1
#define 	SGI_RGB             3
#define 	SGI_RGBA            4
